/*
 * Copyright (c) 2006 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this
 * file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
#include <libc.h>

#include <IOKit/kext/KXKextManager.h>

extern KXKextManagerLogLevel   g_verbose_level;
extern const char *progname;

CFStringRef createCFString(char * string);

Boolean check_file(const char * filename);
Boolean check_dir(const char * dirname, int writeable, int print_err);
void qerror(const char * format, ...);
void verbose_log(const char * format, ...);
void error_log(const char * format, ...);
int user_approve(int default_answer, const char * format, ...);
const char * user_input(const char * format, ...);

int addKextsToManager(
    KXKextManagerRef aManager,
    CFArrayRef kextNames,
    CFMutableArrayRef kextArray,
    Boolean do_tests);

int fork_program(
    const char * argv0,
    char * const argv[],
    int delay,
    Boolean wait);
